%HouseHolder for computing eigenvalues
%Example 
 A=[4 1 -2 2; 1 2 0 1; -2 0 3 -2;2 1 -2 -1]
n=size(A,2);
I=eye(n);
alpha=-sign(A(2,1))*sqrt(sum(A(2:n,1).^2))
r=sqrt(0.5*(alpha^2-A(2,1)*alpha));
v(1)=0;
v(2)=(A(2,1)-alpha)/(2*r);
for k=3:n
v(k)=A(k,1)/(2*r)
end
P=I-2*v'*v
 A=P*A*P'
for k=2:n-1
    alpha=-sign(A(k+1,k))*sqrt(sum(A(k+1:n,k).^2));
r=sqrt(0.5*(alpha^2-A(k+1,k)*alpha));
v(1:k)=0;
v(k+1)=(A(k+1,k)-alpha)/(2*r);
for j=k+2:n
    v(j)=A(j,k)/(2*r);
end
P=I-2*v'*v;
A=P*A*P';
end
A
